LeetCode #4 Median of Two Sorted Arrays (H)

[Problem]

There are two sorted arrays nums1 and nums2 of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)).

[Analysis]

由于两个数组已经是有序的,这题考的是如何将Linear复杂度优化到Log复杂度。那么很容易就能想到二分法或者说分治算法(Divide and Conquer)。这题我的思路是利用一般的在有序数组里找第K个元素的方法,来找到中数。需要注意的是中数可能是两个数的平均值。基本上难点在于思路的转化以及小心地将递归的所有情况列出来。

[Solution]

public class Solution {
    public double findMedianSortedArrays(int A[], int B[]) {
        int m = A.length;
        int n = B.length;

        if ((m + n) % 2 == 0) {
            int median1 = findKSortedArrays(A, 0, m, B, 0, n, (m + n)/2);
            int median2 = findKSortedArrays(A, 0, m, B, 0, n, (m + n)/2 + 1);
            return 1.0 * (median1 + median2)/2;
        } else {
            return 1.0 * findKSortedArrays(A, 0, m, B, 0, n, (m + n)/2 + 1);
        }
    }

    public int findKSortedArrays(int A[], int lowerA, int upperA, int B[], int lowerB, int upperB, int k) {
        int m = upperA - lowerA;
        int n = upperB - lowerB;    

        if (m <= 0) {
            return B[lowerB + k - 1];
        }

        if (n <= 0) {
            return A[lowerA + k - 1];
        }

        if (k == 1) {
            return A[lowerA] < B[lowerB]? A[lowerA] : B[lowerB];
        }

        int midA = (lowerA + upperA - 1) / 2; // (upperA - 1 - lowerA) / 2 + lowerA
        int midB = (lowerB + upperB - 1) / 2;

        if (A[midA] <= B[midB]) {
            if (midA - lowerA + midB - lowerB + 2 <= k) {
                return findKSortedArrays(A, midA + 1, upperA, B, lowerB, upperB, k - (midA - lowerA + 1));
            } else {
                return findKSortedArrays(A, lowerA, upperA, B, lowerB, midB, k);
            }
        } else {
            if (midA - lowerA + midB - lowerB + 2 <= k) {
                return findKSortedArrays(A, lowerA, upperA, B, midB + 1, upperB, k - (midB - lowerB + 1));
            } else {
                return findKSortedArrays(A, lowerA, midA, B, lowerB, upperB, k);
            }
        }
    }
}
时间: 2024-08-07 18:15:04

LeetCode #4 Median of Two Sorted Arrays (H)的相关文章

LeetCode(3) || Median of Two Sorted Arrays

LeetCode(3) || Median of Two Sorted Arrays 题记 之前做了3题,感觉难度一般,没想到突然来了这道比较难的,星期六花了一天的时间才做完,可见以前基础太差了. 题目内容 There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should

【题解】【数组】【Leetcode】Median of Two Sorted Arrays

Median of Two Sorted Arrays There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22

LeetCode OJ - Median of Two Sorted Arrays

题目: There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). 解题思路: 将原问题转变成一个寻找第k小数的问题(假设两个原序列升序排列),这样中位数实际上是第(m+n)/2小的数.所以只要解决了第k小数的问题,原问题也得以解决

[LeetCode][JavaScript]Median of Two Sorted Arrays

Median of Two Sorted Arrays There are two sorted arrays nums1 and nums2 of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). https://leetcode.com/problems/median-of-two-sorted

第三周 leetcode 4. Median of Two Sorted Arrays (HARD)

4. Median of Two Sorted Arrays 给定两个有序的整数序列.求中位数,要求复杂度为对数级别. 通常的思路,我们二分搜索中位数,对某个序列里的某个数 我们可以在对数时间内通过二分算法求得两个序列中比它小的数,整体复杂度也是对数级别.但是代码实现较为困难. 换一个思路,我们把中位数不要当作一个数,而当作一个序列的划分.划分后,序列的左半部设为L,右半部设为R 满足max(L)<=min(R)且满足len(L)==len(R) 二分搜索这个划分即可.对于A+B的长度为奇数的情

leetcode 2.Median of Two Sorted Arrays

Median of Two Sorted Arrays Problem: There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). 解题思路:如果是一个已排序数组,求中位数,可以直接计算.因此比较常规的想法是直接将两个有序数组合并

【LeetCode】Median of Two Sorted Arrays (2 solutions)

Median of Two Sorted Arrays There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). 解法一:保底做法,O(m+n)复杂度 按照归并排序的思路,数到median,然后计算返回. 需要注意: 如果是m+n

leetcode之Median of Two Sorted Arrays

Median of Two Sorted Arrays There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)). 首先假设数组A和B的元素个数都大于k/2,我们比较A[k/2-1]和B[k/2-1]两个元素,这两个元素分别表示A的

[LeetCode][Python]Median of Two Sorted Arrays

# -*- coding: utf8 -*-'''https://oj.leetcode.com/problems/median-of-two-sorted-arrays/ There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays.The overall run time complexity should be O(log (m+n)).